package nl.sbdeveloper.themeparkplus.util;

import com.sk89q.worldedit.IncompleteRegionException;
import com.sk89q.worldedit.LocalSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.WorldEditPlugin;
import com.sk89q.worldedit.bukkit.selections.Polygonal2DSelection;
import com.sk89q.worldedit.bukkit.selections.Selection;
import com.sk89q.worldedit.regions.Polygonal2DRegion;
import com.sk89q.worldedit.regions.Region;
import com.sk89q.worldedit.world.World;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.Nullable;

public class WEUtil {
    private static boolean newVersion;
    private static WorldEditPlugin wep;

    public WEUtil() {
        newVersion = XMaterial.isNewVersion();
        wep = (WorldEditPlugin) Bukkit.getPluginManager().getPlugin("WorldEdit");
    }

    @Nullable
    public static Region getSelection(Player p) {
        if (newVersion) {
            LocalSession l = WorldEdit.getInstance().getSessionManager().get(BukkitAdapter.adapt(p));
            Region s;
            try {
                s = l.getSelection(l.getSelectionWorld());
            } catch (IncompleteRegionException e) {
                return null;
            }
            if (s instanceof Polygonal2DSelection) {
                Polygonal2DSelection polySel = (Polygonal2DSelection) s;
                int minY = polySel.getNativeMinimumPoint().getBlockY();
                int maxY = polySel.getNativeMaximumPoint().getBlockY();
                return new Polygonal2DRegion((World) polySel.getWorld(), polySel.getNativePoints(), minY, maxY);
            }
        } else {
            Selection sel = wep.getSelection(p);
            if (sel instanceof Polygonal2DSelection) {
                Polygonal2DSelection polySel = (Polygonal2DSelection) sel;
                int minY = polySel.getNativeMinimumPoint().getBlockY();
                int maxY = polySel.getNativeMaximumPoint().getBlockY();
                return new Polygonal2DRegion((World) polySel.getWorld(), polySel.getNativePoints(), minY, maxY);
            }
        }
        return null;
    }
}
